/* Tataroiu Bogdan-Cristian */
/* The Avengers - Siberian Mosquito */

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

#define MAXN 100000
#define MAXM 100000
#define MAXC 64
#define MAXlogN 17

static int N, M;
static int mx[MAXN - 1], my[MAXN - 1], mc[MAXN - 1];
static int deg[MAXN], *con[MAXN];
static int p[MAXlogN][MAXN], depth[MAXN], sum[MAXN], log2[MAXN];
static int max_down[MAXN], max_down_nod[MAXN];
static int max_up[MAXN], max_up_nod[MAXN];

void dfs_max_down(int k) {
    int *i;
    max_down[k] = 0;
    max_down_nod[k] = k;
    for (i = con[k]; *i != -1; i++) {
        int l = mx[*i] ^ my[*i] ^ k;
        if (p[0][k] == l) {
            continue;
        }

        p[0][l] = k;
        depth[l] = depth[k] + 1;
        sum[l] = sum[k] + mc[*i];
        dfs_max_down(l);
        if (max_down[l] + mc[*i] > max_down[k]) {
            max_down[k] = max_down[l] + mc[*i];
            max_down_nod[k] = max_down_nod[l];
        }
    }
}

void dfs_max_up(int k) {
    int *i;
    int max_dist_fiu = 0, max_fiu = -1;
    int max_dist_fiu_2 = 0, max_fiu_2 = -1;
    for (i = con[k]; *i != -1; i++) {
        int l = mx[*i] ^ my[*i] ^ k, cst = max_down[l] + mc[*i];
        if (p[0][k] == l) {
            continue;
        }

        if (cst > max_dist_fiu) {
            max_dist_fiu_2 = max_dist_fiu;
            max_fiu_2 = max_fiu;

            max_dist_fiu = cst;
            max_fiu = l;
        } else if (cst > max_dist_fiu_2) {
            max_dist_fiu_2 = cst;
            max_fiu_2 = l;
        }
    }

    for (i = con[k]; *i != -1; i++) {
        int l = mx[*i] ^ my[*i] ^ k;
        if (p[0][k] == l) {
            continue;
        }

        max_up[l] = max_up[k] + mc[*i];
        max_up_nod[l] = max_up_nod[k];
        if (l != max_fiu) {
            if (max_dist_fiu + mc[*i] > max_up[l]) {
                max_up[l] = max_dist_fiu + mc[*i];
                max_up_nod[l] = max_down_nod[max_fiu];
            }
        } else {
            if (max_dist_fiu_2 + mc[*i] > max_up[l]) {
                max_up[l] = max_dist_fiu_2 + mc[*i];
                max_up_nod[l] = max_down_nod[max_fiu_2];
            }
        }
        dfs_max_up(l);
    }
}

inline int lca(int A, int B) {
    for (; depth[A] > depth[B]; A = p[log2[depth[A] - depth[B]]][A]);
    for (; depth[A] < depth[B]; B = p[log2[depth[B] - depth[A]]][B]);

    if (A == B) {
        return A;
    }

    int step = log2[depth[A]];
    for (; step >= 0; step -= 1) {
        if (p[step][A] != p[step][B]) {
            A = p[step][A];
            B = p[step][B];
        }
    }
    return p[0][A];
}

inline void bin_search_parent(int nod, int up) {
    int step = log2[depth[nod]];
    for (; step >= 0; step -= 1) {
        if (sum[nod] - sum[p[step][nod]] <= up) {
            up -= sum[nod] - sum[p[step][nod]];
            nod = p[step][nod];
        }
    }
    if (nod != 0) {
        printf("%d %d %d\n", nod + 1, p[0][nod] + 1, up);
    } else {
        printf("%d %d %d\n", 1, (mx[con[0][0]] ^ my[con[0][0]]) + 1, 0);
    }
}

int main() {
    int i;
    /* Precalculeaza logaritm in baza 2 */
    log2[1] = 0;
    for (i = 2; i < MAXN; i++) {
        log2[i] = log2[i - 1];
        if (i == (1 << (log2[i] + 1))) {
            log2[i] += 1;
        }
    }

    freopen("hacker.in", "rt", stdin);
    freopen("hacker.out", "wt", stdout);

    assert(scanf("%d %d", &N, &M) == 2);
    assert(1 <= N && N <= MAXN);
    assert(1 <= M && M <= MAXM);
    /* Citeste muchiile */
    for (i = 0; i + 1 < N; i++) {
        assert(scanf("%d %d %d", mx + i, my + i, mc + i) == 3);
        assert(1 <= mx[i] && mx[i] <= N);
        assert(1 <= my[i] && my[i] <= N);
        assert(mx[i] != my[i]);
        assert(1 <= mc[i] && mc[i] <= MAXC);

        mx[i] -= 1; my[i] -= 1;
        deg[mx[i]] += 1;
        deg[my[i]] += 1;
    }
    /* Aloca memorie pentru muchiile fiecarui nod */
    for (i = 0; i < N; i++) {
        con[i] = malloc(sizeof(int) * (deg[i] + 1));
        con[i][deg[i]] = -1;
    }
    for (i = 0; i + 1 < N; i++) {
        con[mx[i]][--deg[mx[i]]] = i;
        con[my[i]][--deg[my[i]]] = i;
    }

    /* Calculeaza pentru fiecare nod, nodul care se afla la distanta maxima de
       acesta */
    p[0][0] = 0;
    dfs_max_down(0);
    dfs_max_up(0);

    /* Calculeaza pentru fiecare nod parintii de ordin 2^k */
    for (i = 1; (1 << i) < N; i++) {
        int j;
        for (j = 0; j < N; j++) {
            p[i][j] = p[i - 1][p[i - 1][j]];
        }
    }

    /* Raspunde la query-uri */
    /* Dorinta mea ti-e comanda, boss */
    for (i = 0; i < M; i++) {
        int nod, dist;
        assert(scanf("%d %d", &nod, &dist) == 2);
        assert(1 <= nod && nod <= N);
        assert(1 <= dist && dist <= MAXC * (N - 1));
        nod -= 1;

        int ref;
        if (max_down[nod] > max_up[nod]) {
            ref = max_down_nod[nod];
        } else {
            ref = max_up_nod[nod];
        }

        int LCA = lca(nod, ref);
        if (sum[nod] - sum[LCA] >= dist) {
            bin_search_parent(nod, dist);
        } else {
            bin_search_parent(ref, sum[ref] - dist + sum[nod] - 2 * sum[LCA]);
        }
    }

    return 0;
}
