//Andrei Parvu
//The Avengers - White Death
//Edmonds-Karp cu Bellman Ford

#include <cstdio>
#include <cassert>
#include <cstring>
#include <vector>
#include <queue>

using namespace std;

#define x first
#define y second
#define ii pair<int, int>

const int lg = 255, MAXN = 250, MAXM = 250, MAXK = 1000, MAXCOST = 30000,
	  inf = 0x3f3f3f3f;

int n, m, k, x, y, c, Cap[lg][lg], Cost[lg][lg], prd[lg], cnt[lg], i, j;
vector<int> v[lg];
bool fst[lg];
ii rez, rsp;

int flux(int stop){
	for (i = 0; i <= n + m + 1; i ++){
		fst[i] = 0;
		prd[i] = -1;
		cnt[i] = inf;
	}
	
	queue<int> q;
	q.push(0);
	cnt[0] = 0; fst[0] = 1;

	while (!q.empty()){
		x = q.front(); q.pop();

		for (int i = 0; i < (int)v[x].size(); i ++)
			if (Cap[x][ v[x][i] ] > 0 && cnt[x] + Cost[x][ v[x][i] ] < 
					cnt[ v[x][i] ]){
				cnt[ v[x][i] ] = cnt[x] + Cost[x][ v[x][i] ];
				prd[ v[x][i] ] = x;

				if (!fst[ v[x][i] ]){
					fst[ v[x][i] ] = 1;
					q.push(v[x][i]);
				}
			}

		fst[x] = 0;
	}

	if (cnt[n + m + 1] == inf)
		return 0;

	rez.y += cnt[n + m + 1];
	rez.x ++;

	for (x = n + m + 1; prd[x] != -1; x = prd[x]){
		Cap[ prd[x] ][x] --;
		Cap[x][ prd[x] ] ++;

		//Cost[x][ prd[x] ] = -Cost[ prd[x] ][x];
	}

	//printf("%d %d  %d\n", rez.x, rez.y, Cap[7][9]);

	if (stop >= n && rez.y < rsp.y)
		rsp = rez;

	if (rez.x == stop)
		return 0;

	return 1;
}

int main(){
	freopen("terenuri3d.in", "rt", stdin);
	freopen("terenuri3d.out", "wt", stdout);

	scanf("%d%d%d", &n, &m, &k);

	assert(1 <= n && n <= MAXN && 1 <= m && m <= MAXM && 1 <= k && k <= MAXK);

	for (i = 1; i <= k; i ++){
		scanf("%d%d%d", &x, &y, &c);

		assert(1 <= x && x <= n && 1 <= y && y <= m && 1 <= c && c <= MAXCOST);

		y += n;

		v[x].push_back(y);
		v[y].push_back(x);

		Cap[x][y] = 1;
		Cost[x][y] = -c, Cost[y][x] = c;
	}

	for (i = 1; i <= n; i ++){
		v[0].push_back(i);
		v[i].push_back(0);

		Cap[0][i] = 1;
	}

	for (i = 1; i <= m; i ++){
		v[n + i].push_back(n + m + 1);
		v[n + m + 1].push_back(n + i);

		Cap[n + i][n + m + 1] = 1;
	}

	do{
		x = flux(n + 2);
	}
	while (x > 0);

	memset(Cap, 0, sizeof(Cap));

	for (i = 1; i <= n; i ++){
		Cap[0][i] = 1;
	}

	for (i = 1; i <= m; i ++){
		Cap[n + i][n + m + 1] = 1;
	}

	for (int nod = 1; nod <= n; nod ++)
		for (j = 0; j < (int)v[nod].size(); j ++)
			if (v[nod][j] > 0)
				Cap[nod][ v[nod][j] ] = 1;

	rez.x = rez.y = 0;
	do{
		x = flux(rsp.x);
	}
	while (x > 0);

	printf("%d\n%d\n", -rez.y, rez.x);

	for (i = 1; i <= n; i ++)
		for (j = 0; j < (int)v[i].size(); j ++)
			if (Cap[i][ v[i][j] ] == 0 && v[i][j] > 0)
				printf("%d %d\n", i, v[i][j] - n);

	return 0;
}

