//Robert Hasna

#include <cstdio>
#include <vector>
#include <queue>
#include <cstring>

#define Nmax 2002

using namespace std;


int N, M, K;
vector< int > G[Nmax];
int F[Nmax][Nmax];
int C[Nmax][Nmax];
int cost[Nmax][Nmax];
int max_value;
int dist[Nmax], back[Nmax], uz[Nmax];
int S, D;
queue<int> Q;
int pas2 = 0, cost_max = 0;

void afis();

void clear() {
	for (int i = 0; i <= D; ++i) {
		dist[i] = back[i] = uz[i] = 0;
		for (int j = 0; j <= D; ++j) {
			F[i][j] = 0;
		}
	}
}

bool bellman_ford() {
	//printf("in bellman_ford\n");
	memset(dist, -1, Nmax*sizeof(int));
	Q.push(S);
	dist[S] = 0;

	while (!Q.empty()) {
		//afis();
		//printf("Q.size : %d\n", Q.size());
		int x = Q.front();
		Q.pop();

		for (vector<int>::iterator it = G[x].begin(); it != G[x].end(); ++it) {
			if (F[x][*it] < C[x][*it] && (dist[*it] == -1 || dist[x] + cost[x][*it] < dist[*it])) {
				dist[*it] = dist[x] + cost[x][*it];
				back[*it] = x;
				Q.push(*it);
			}
		}
	}
	//printf("afara din bellman ford\n");
	return dist[D] != -1;
}

void afis() {
	printf("dist : ");
	for (int i = 0; i <= D; ++i) printf("%d ", dist[i]);
	printf("\nC[][] : \n");
	for (int i = 0; i <= D; ++i) {
		for (int j = 0; j <= D; ++j) {
			printf("%d ", C[i][j]);
		}
		printf("\n");
	}

	printf("F[][] : \n");
	for (int i = 0; i <= D; ++i) {
		for (int j = 0; j <= D; ++j) {
			printf("%d ", F[i][j]);
		}
		printf("\n");
	}

	printf("\n\n\n");
}

int getCost() {
	//printf("in getCost\n");
	memset(uz, 0, Nmax*sizeof(int));
	while (!Q.empty()) Q.pop();
	Q.push(S);
	uz[S] = 1;
	int rez = 0;
	while (!Q.empty()) {
		int x = Q.front();
		Q.pop();
		for (vector<int>::iterator it = G[x].begin(); it != G[x].end(); ++it) 
			if (F[x][*it] > 0 && !uz[*it]) {
				Q.push(*it);
				rez += cost[x][*it];
				uz[*it] = 1;
			}
	}
	//printf("afara din getCost\n");
	return rez;
}

void flux() {
	//printf("in flux\n");
	while (bellman_ford()) {
		//pot mari fluxul
		//printf("in while\n");
		int x = D;
		while (x != S) {
			//printf("aici\n");
			int y = back[x];
			F[y][x] += 1;
			F[x][y] -= 1;
			x = y;
		}

		int CC = getCost(), cnt = 0;
		for (int i = 1; i <= M; ++i) cnt += F[N + i][D];

		//costul cuplajului este :
		int temp = cnt * max_value - CC;
		if (!pas2) {
			if (temp > cost_max) cost_max = temp;
		}
		else {
			if (temp == cost_max)
				break;
		}
	}
	//printf("afara din while\nafara din flux\n");
}

int main() {
	freopen("terenuri3d.in", "r", stdin);
	freopen("terenuri3d.out", "w", stdout);

	scanf("%d %d %d\n", &N, &M, &K);
	for (int i = 0; i < K; ++i) {
		int x, y, z;
		scanf("%d %d %d\n", &x, &y, &z);
		G[x].push_back(N+y);
		cost[x][N+y] = z;
		C[x][N+y] = 1;

		G[N+y].push_back(x);

		if (z > max_value) max_value = z;
	}

	for (int i = 1; i <= N; ++i) {
		for (vector<int>::iterator it = G[i].begin(); it != G[i].end(); ++it) {
			cost[i][*it] = max_value - cost[i][*it];
			cost[*it][i] = -cost[i][*it];
		}
	}
		
	S = 0;
	for (int i = 1; i <= N; ++i) {
		G[S].push_back(i);
		C[S][i] = 1;
	}
	D = N + M + 1;
	for (int i = 1; i <= M; ++i) {
		G[N + i].push_back(D);
		C[N + i][D] = 1;
	}

	flux();
	pas2 = 1;
	clear();
	flux();
	
	int nr = 0;
	for (int i = 1; i <= M; ++i) 
		if (F[N+i][D] > 0)
			nr += F[N + i][D];
	printf("%d\n%d\n", cost_max, nr);

	for (int i = 1; i <= M; ++i)
		if (F[N + i][D] > 0) {
			for (vector<int>::iterator it = G[N+i].begin(); it != G[N+i].end(); ++it)
				if (F[*it][N + i] > 0) 
					printf("%d %d\n", *it, i);
		}
	return 0;
}

